signature Gamma =
sig
    type gamma

(*  legt leeren Gamma graphen an *)
    val empty : unit -> gamma

(* fuegt dem Graphen gamma Variablen hinzu *)
    val add_gamma : gamma * int -> gamma

(* fuegt dem Graphen delta Varibalen, und 
 * entsprechend der bereits vorhandenen gamma variablen,
 * Kanten zu denselben hinzu
 *)
    val add_delta : gamma * int -> gamma

(* Wenn Gamma Variable i durch Term t ersetzt werden soll,
 * muss geprueft werden, ob evtl. Abhaengigkeiten zwischen 
 * i und den freien Variablen in t bestehen 
 * Data.pter list enthaelt die freien Variablen des Terms t
 *
 * Darf ersetzt werden, so werden entsprechende Kanten zum Graph
 * hinzugefuegt und true zurueckgegeben
 * Im Falle von Zyklen wird false zurueckgegeben
 *)
    val substitute : gamma -> ( int * Data.pter list) -> bool

(* Gibt die Anzahl, deklarierter Gamma Variablen zurueck *)
    val nr_gammavars : gamma -> int

end