local open Data Goal in

(* Wende Reflexivitaet, Symmetrie und Transitivitaet
 * nur auf erste Conclusion an !!!
 *)


(* ******************************** *)
(* Gleichheitsregel : REFLEXIVITAET *)
(* ******************************** *)

fun reflexiv (goal) = 
    let
	val pter = Goal.get_first_goal(goal)
	val (conclusion) = 
	    ( case pter of
		  (IMP(l,r)) => r 
		| _ => raise Error ("Internal Error in RefSymTrans\n") )

	val (left, right) = ( case conclusion of
			    (EQ (l,r))       => (l,r) 
                          | (OR (EQ(l,r),_)) => (l,r)
			  | _         => raise Error ("You can only apply Reflexivity-Rule to equalities"))

	(* Wenn sie wirklich gleich sind, dann genuegt nur noch die Conclusion *)
	val newpter = if (ETT.equal(left,right)) then (C "TRUE") else pter
	val newgoal = Goal.update_first_goal(goal, newpter)
    in
	(Goal.print_goal(newgoal) ; newgoal)
    end


(* ******************************** *)
(* Gleichheitsregel : SYMMETRIE     *)
(* ******************************** *)

fun symmetrie (goal,d) = 
    let
	val pter = Goal.get_first_goal(goal)
	val (premise, conclusion) = 
	    ( case pter of
		  (IMP(l,r)) => (l,r)
		| _ => raise Error ("Internal Error in RefSymTrans\n") )

	val newpter = ( case d of 
                        RIGHT => ( case conclusion of
				  (EQ (l,r))          => (IMP(premise, EQ(r,l)))
				| (OR (EQ(l,r),rest)) => (IMP(premise, OR( EQ(r,l), rest)))
				| _         => raise Error ("You can only apply Symmetric-Rule to equalities\n"))

		      | LEFT  => ( case premise of
				  (EQ (l,r))          => (IMP(EQ(r,l), conclusion))
				| (AND (EQ(l,r),rest))=> (IMP(AND( EQ(r,l), rest), conclusion))
				| _         => raise Error ("You can only apply Symmetric-Rule to equalities\n")) )
			    
	val newgoal = Goal.update_first_goal(goal, newpter)
    in
	(Goal.print_goal(newgoal) ; newgoal)
    end


(* *********************************** *)
(* Gleichheitsregel : TRANSITIVITAET   *)
(* *********************************** *)

val err = ("You can apply transitivity only on equalities\n") 
fun trans_conclusion' formel goal = 
    let
	val pter = Goal.get_first_goal(goal)
	val (left,right) = 
	   ( case pter of
		IMP(l,r) => (l,r)
	      |_     => raise Error("Interner Fehler in RefSymTrans 1\n"))

	(* Update formel *)
	val updatepter = IMP( left, ( case right of 
				     EQ(l,_) => (EQ(l, formel))
				   | OR(EQ(l,_),B) => (OR(EQ(l, formel), B))
				   | _ => raise Error err ) )
		 
    	val newgoal' = Goal.update_first_goal(goal,updatepter)

	(* neues goal *)
	val newpter = IMP( left, ( case right of 
				  EQ (_,r) => (EQ(formel, r))
				| OR(EQ(_,r), B) => (OR(EQ(formel, r), B))
				| _ => raise Error err ) )
	
	val newgoal = Goal.split_goal(newgoal', newpter) 
    in 
	newgoal 
    end

fun trans (goal, f) = 
    let
	val transinit = Goal.init_goal_env(goal)
	val transgoal = Goal.first_goal(transinit, f)

	val formel' = Goal.get_first_goal(transgoal)
	val formel  = ( case (formel') of
		       IMP(C"TRUE", p) => p
		     | _ => raise Error ("Internal Error: Transitivity\n") )

	val mergegoal = Goal.merge_envs(goal, transgoal)
	val newgoal   = trans_conclusion' formel mergegoal
    in
	(Goal.print_goal(newgoal) ; newgoal)
    end


end (* of local open *)

