local open Data Goal in

(* -------------------------------- *)
(* |    Gets the Subterm          | *)
(* -------------------------------- *)

fun getSubTerm (t as (C c)) xs lams = 
    if null(xs) then (t,lams) else raise Error ("Subterm wrong position (End reached - Constant)\n") 
  | getSubTerm (t as (V x)) xs lams = 
	if null(xs) then (t,lams) else raise Error ("Subterm wrong position (End reached - Variable)\n")
  | getSubTerm (t as ((GAMMA _))) xs lams = 
	    if null(xs) then (t,lams) else raise Error ("Subterm wrong position (End reached - Gamma Var) \n")
  | getSubTerm (t as (A(m,m'))) xs lams = if (null(xs)) then (t,lams)
				  else ( case hd(xs) of
					1 => getSubTerm m (tl(xs)) lams
				      | 2 => getSubTerm m'(tl(xs)) lams
				      | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (App)\n") )
					    
  | getSubTerm (t as (L((typ,i),m))) xs lams = if (null(xs)) then (t,lams)
				       else(  case hd(xs) of
					    1 => getSubTerm m (tl(xs)) ((typ,i)::lams)
					  | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (L)\n"))
  | getSubTerm (t as (EX((typ,i),m))) xs lams = if (null(xs)) then (t,lams) 
				       else ( case hd(xs) of
					     1 => getSubTerm m (tl(xs)) ((typ,i)::lams)
					   | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (EX)\n"))
  | getSubTerm (t as (ALL((typ,i),m))) xs lams = if (null(xs)) then (t,lams)
				       else ( case hd(xs) of
					     1 => getSubTerm m (tl(xs)) ((typ,i)::lams)
					   | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (ALL)\n"))

  | getSubTerm (t as (AND(m,m'))) xs lams = if (null(xs)) then (t,lams)
				  else ( case hd(xs) of
					1 => getSubTerm m (tl(xs)) lams
				      | 2 => getSubTerm m'(tl(xs)) lams
				      | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (AND)\n"))

  | getSubTerm (t as (OR(m,m'))) xs lams = if (null(xs)) then (t,lams)
				  else ( case hd(xs) of
					1 => getSubTerm m (tl(xs)) lams
				      | 2 => getSubTerm m'(tl(xs)) lams
				      | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (OR)\n"))
  | getSubTerm (t as (IMP(m,m'))) xs lams = if (null(xs)) then (t,lams)
				  else ( case hd(xs) of
					1 => getSubTerm m (tl(xs)) lams
				      | 2 => getSubTerm m'(tl(xs)) lams
				      | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (IMP)\n"))
  | getSubTerm (t as (EQ(m,m'))) xs lams = if (null(xs)) then (t,lams)
				  else ( case hd(xs) of
					1 => getSubTerm m (tl(xs)) lams
				      | 2 => getSubTerm m'(tl(xs)) lams
				      | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (EQ)\n"))
 | getSubTerm (t as (NOT(m))) xs lams = if (null(xs)) then (t,lams) 
				  else ( case hd(xs) of
					1 => getSubTerm m (tl(xs)) lams
				      | i => raise Error ("Subterm wrong position  " ^ Int.toString(i) ^ " (NOT)\n"))




(* -------------------------------- *)
(* |    Sets the new Subterm      | *)
(* -------------------------------- *)

fun setSubTerm (t as (C c)) xs n = if null(xs) then n else t
  | setSubTerm (t as (V x)) xs n = if null(xs) then n else t
  | setSubTerm (t as (GAMMA _)) xs n = if null(xs) then n else t
  | setSubTerm (t as (A(m,m'))) xs n = if (null(xs)) then n
				  else ( case hd(xs) of
					1 => A(setSubTerm m (tl(xs)) n, m')
				      | 2 => A(m, setSubTerm m'(tl(xs)) n )
				      | i => t )
					    
  | setSubTerm (t as (L((typ,i), m))) xs n = if (null(xs)) then n
					     else ( case hd(xs) of
					    1 => L((typ,i), setSubTerm m (tl(xs)) n )
					  | i => t )

  | setSubTerm (t as (EX((typ,i), m))) xs n = if (null(xs)) then n
				       else ( case hd(xs) of
					    1 => EX((typ,i), setSubTerm m (tl(xs)) n )
					  | i => t )

  | setSubTerm (t as (ALL((typ,i), m))) xs n = if (null(xs)) then n
				       else ( case hd(xs) of
					    1 => ALL((typ,i), setSubTerm m (tl(xs)) n )
					  | i => t )

 
  | setSubTerm (t as (AND(m,m'))) xs n = if (null(xs)) then n
				  else ( case hd(xs) of
					1 => AND(setSubTerm m (tl(xs)) n, m')
				      | 2 => AND(m, setSubTerm m'(tl(xs)) n )
				      | i => t )

  | setSubTerm (t as (OR(m,m'))) xs n = if (null(xs)) then n
				  else ( case hd(xs) of
					1 => OR(setSubTerm m (tl(xs)) n, m')
				      | 2 => OR(m, setSubTerm m'(tl(xs)) n )
				      | i => t )

  | setSubTerm (t as (IMP(m,m'))) xs n = if (null(xs)) then n
				  else ( case hd(xs) of
					1 => IMP(setSubTerm m (tl(xs)) n, m')
				      | 2 => IMP(m, setSubTerm m'(tl(xs)) n )
				      | i => t ) 

  | setSubTerm (t as (EQ(m,m'))) xs n = if (null(xs)) then n
				  else ( case hd(xs) of
					1 => EQ(setSubTerm m (tl(xs)) n, m')
				      | 2 => EQ(m, setSubTerm m'(tl(xs)) n )
				      | i => t )
  | setSubTerm (t as (NOT(m))) xs n = if (null(xs)) then n 
				  else ( case hd(xs) of
					1 => NOT(setSubTerm m (tl(xs)) n)
				      | i => t )


fun get_premisse (AND(a,b)) i = if i <= 1 then a else get_premisse b (i-1)
  | get_premisse t i = if i = 1 then t else raise Error ("No Premisse found !\n")



(* returns the max. Free Variable of the fixterm *)       
val HighestFreeVar = foldl ( fn (x,n)=> case x of (V i) => if i > n then i else n | _ => n ) 0 

(* Umrechnung der Position *)
(* Passe Position der aktuellen Ausgabe an !! *)
(* Spezialfall 0 fuer Formeldeduktion *)
fun getPosSequenz (0::nil) _ = nil
  | getPosSequenz xs (IMP(C "TRUE", _)) = (2::xs)
  | getPosSequenz xs _ = xs
 

(* returns Tupel (match,destination) in Abhaengigkeit 
 * von LEFT / RIGHT 
 *)
fun MatchDest  (EQ(l,r)) d  = if (d = LEFT) then (l,r) else (r,l)
  | MatchDest (IMP(l,r)) d  = if (d = RIGHT) then (r,l) else 
    raise Error ("In case of => Lemmata, please choose <r>")
  | MatchDest  _ _ =  raise Error ("No Equational Axiom/Lemma/Premisse \n") 
	      

(* Translates the Positions List [LA "A", PO 1, PO 2 , ... ]
 * in IntegerList [2,1,1,2,... ]
 *)

fun translabel pter ord =
let
    val label = ref 65 (* initial auf #"A" *)

    fun exp (L((t,i),e)) xs = 
	let val clabel = !label
	in ( label := !label + 1 ; (* erhoehe label counter *)
	    (if (clabel = ord) then xs else exp e (xs @ [1])) )
	end

      | exp (EX((t,i),e)) xs = 
	let val clabel = !label
	in ( label := !label + 1 ; 
	     (if (clabel = ord) then xs else exp e (xs @ [1])) )
	end

      | exp (ALL((t,i),e)) xs = 
	let val clabel = !label
	in ( label := !label + 1 ; 
	    (if (clabel = ord) then xs else exp e (xs @ [1])) )
	end

      | exp t xs = eqexp t xs
	    
    and eqexp (EQ(a,b)) xs =
	let val clabel = !label
	in ( label := !label + 1 ; 
	    (if (clabel = ord) then xs 
	   (* works, because the false side has list nil 
	    * and impexp will be evaluated first !! 
	    *)
	     else ( impexp a (xs @ [1])) @ ( eqexp b (xs @ [2])) ))
	end
						 
      | eqexp t xs = impexp t xs
	    
    and impexp (IMP(a,b)) xs = 
	let val clabel = !label
	in ( label := !label + 1 ;
	    ( if (clabel = ord) then xs 
	      else ( orexp a (xs @ [1])) @ ( impexp b (xs @ [2])) ))
	end

      | impexp t xs = orexp t xs
	    
    and orexp (OR(a,b)) xs =
	let val clabel = !label
	in ( label := !label + 1 ;
	     (if (clabel = ord) then xs 
	      else ( andexp a (xs @ [1]) ) @ ( orexp b (xs @ [2])) ))
	end
	
      | orexp t xs = andexp t xs
	    
    and andexp (AND(a,b)) xs =
	let val clabel = !label
	in ( label := !label + 1 ;
	     ( if (clabel = ord) then xs
	       else ( negexp a (xs @ [1]) ) @ ( andexp b (xs @ [2]) )))
	end
	 
      | andexp t xs = negexp t xs
	    
    and negexp (NOT(a)) xs =
	let val clabel = !label
	in ( label := !label + 1 ;
	    (if (clabel = ord) then xs else negexp a (xs @ [1]) ))
	end
	    
      | negexp t xs = appexp t xs
	    
    and appexp (A(a,b)) xs = 
	( appexp a (xs @ [1])) @ ( atexp b (xs @ [2]) )
	
      | appexp t xs = atexp t xs
	    
    and atexp (V(n)) xs = 
	let val clabel = !label
	in ( label := !label + 1 ;
	    ( if (clabel = ord ) then xs else nil )) 
	end
	
      | atexp (GAMMA(_,i)) xs = nil
	
      | atexp (C(s)) xs = 
	let val clabel = !label
	in ( label := !label + 1 ;
	    ( if (clabel = ord ) then xs else nil )) 
	end

      | atexp t xs = exp t xs
	   
in
    exp pter nil
end (* of translate *)

(* Translates Pos Liste into int liste *)
fun pos2intlist ((LA s)::xs) = raise Error "Parser filters Positionlist - Rewriting Internal #1\n"
  | pos2intlist ((PO i)::xs ) = i::(pos2intlist xs)
  | pos2intlist  nil = nil

(*    
fun debuglist' (i::is) = ( print (Int.toString(i) ^ " "); debuglist'(is))
  | debuglist' nil = ()
fun debuglist is = ( print( "\n[" ) ;  debuglist' is ; print ("]\n") )
*)

fun translate _ (liste as ((PO i)::xs))   = pos2intlist liste
  | translate pter (liste as ((LA s)::xs)) = 
    let val c = ( case (Char.fromString s ) of 
		 (SOME c) => c 
	       | (NONE) => raise Error "Position List Error, please use [LABEL](1|2)* \n" )
	
	val newlist = ( case pter of 
		       (IMP (C"TRUE", p)) => translabel p (Char.ord(c))
		     | _ => raise Error "Labels in ND-Mode not available\n" )   
    in
	(newlist @ (pos2intlist xs))
    end
 | translate _ nil = nil
(* | translate _ _ = raise Error "Translation Process Pos2Int List Error - Rewriting #2 \n" *)
    
	    
(* -------------------------------- *)
(* |    Main Procedures           | *)
(* -------------------------------- *)

fun BetaEtaRed goal (xs,mode) = 
    let val pter = Goal.get_first_goal(goal)
	val position = getPosSequenz xs pter
	(* Hole betreffenden Subterm *)
        val (subterm,_) = getSubTerm pter position nil
	(* ruft den Beta/Eta-Reduktions Algorithmus in Lambda.sml auf *)
	val red_subterm = 
	    case mode of
		BETA => Lambda.justbeta(subterm)
	      | ETA => Lambda.justeta(subterm)
	      | _ => raise Error ("in BetaEtaRed Rewriting Module \n")
	(* Ersetze den alten subterm durch den beta/etareduzierten *)
	val newpter = setSubTerm pter position red_subterm
	val newgoal = Goal.update_first_goal(goal, newpter)
    in
	(Goal.print_goal(newgoal); newgoal )
    end


(* Nimmt den subterm(fixterm), das entaprechende
 * Lemma/Axiom in Form einer Gleichung (A=B) und den lamlevel
 *
 * Der Matchingalgorithmus versucht A mit dem fixterm zu matchen
 * und gibt B ( entsprechend gematcht aus 
 *)
fun startMatching (fixterm, d) (freeterm) lamlevel =
let
	(* Passe freeterm an den Lambda Level des Fixterms an *)
	val def  = ETT.up 0 freeterm lamlevel 

	(* Muessen dafuer sorgen, dass die Menge der subterm/fixterm Freien Variablen und
	 * die Menge der def Variablen disjunct sind !! 
	 * => Hebe alle freien Variablen in def um die max. Variable + 1 des subterm an
	 *)
	val disjunctup    =((HighestFreeVar (ETT.getfreevars fixterm)) + 1)
	val tempdef       = ETT.up 0 def disjunctup
	
	                                                            

	(* axiom name = ( A = B ) 
	 * 
	 *  If   d = LEFT  ==> (match, destination) = ( A, B )
                 d = RIGHT ==>                      = ( B, A )
	 *)

	val (match, destination) = MatchDest tempdef d
	  
	(* DEBUG 
	 val _ = print ("AXIOM/PREMISSE FREE (LEFT) : " ^ (Visual.pter2string match) ^ "\n" )
         val _ = print ("AXIOM/PREMISSE FREE (RIGHT): " ^ (Visual.pter2string destination) ^ "\n\n" )
	 *)

	(* Starte Unifikation *)
	val unifier = Unify.getUnifier (fixterm, match) (lamlevel + disjunctup)
	(* DEBUG val _ = ( print ("Unifier :\n") ; Unify.show_unifier(unifier) ) *)
	
	(* noch temporaer angehobene destination *)
	val newdest_up = Unify.subst_wrt_unifier (destination, unifier)
	(* mache temp anhebung an den ausstehenden Variablen des freeterms wieder rueckgaengig *)
	val newdest    = ETT.down disjunctup newdest_up disjunctup
	(* DEBUG val _ = print (("NEUER SUBTERM : " ^ Visual.pter2string newdest) ^ "\n") *)
in
    newdest
end



(* ---------------------------------------------------------------------
 *                              [ MAIN ]
 * ---------------------------------------------------------------------
 *)


(* -------------------------------------------------------------- *)
(*                     Beta Eta - Fall                         *)
(* -------------------------------------------------------------- *)

fun main'(goal, (xs, BETA)) = BetaEtaRed goal (xs,BETA)
  | main'(goal, (xs, ETA))  = BetaEtaRed goal (xs,ETA)


(* -------------------------------------------------------------- *)
(*                   Equality  - Fall                             *)
(* -------------------------------------------------------------- *)

  | main'(goal, (xs, EQUALITY(f))) = 
    let 
	val pter = Goal.get_first_goal(goal)
	val position = getPosSequenz xs pter
	val (subterm, lambdas) = getSubTerm pter position nil
	val lamlevel = List.length(lambdas)

	(* Hole neue Formel und Uebersetze sie in PTER *)
	val instinit = Goal.init_goal_env(goal)
	val instgoal = Goal.first_goal(instinit, f)
	val formel'  = Goal.get_first_goal(instgoal)
	val formel = ( case formel' of
		      (IMP(C "TRUE", m )) => m
			  | _ => raise Error ("Internal Error in Rewriting Module (1)\n") )

	(* Formel must be an equality !! *)
	val newdest = startMatching (subterm, LEFT) (formel) lamlevel
	(* Setze den gematchten Term *)
	val newpter = setSubTerm pter position newdest
	
	val mergegoal = Goal.merge_envs(goal, instgoal)
	val newgoal'  = Goal.update_first_goal(mergegoal, newpter)
	val newgoal'' = Goal.split_goal(newgoal', formel') (* formel' wegen IMP(C"TRUE",formel) Invarianz *)
	val newgoal = Goal.kaper_check(newgoal'')
    in
	(Goal.print_goal(newgoal); newgoal )
    end

(* -------------------------------------------------------------- *)
(*                     Praemissen - Fall                          *)
(* -------------------------------------------------------------- *)


  | main'(goal, (xs, (PREMISSE(nr,d)) ) ) = 
    let 
	(* remove_dbl loescht das Doppelauftreten der Variablen in der Liste *)
	fun remove_dbl xs = foldr ( fn (x,nil) => [x] | (x,ys) => if x = hd(ys) then ys else x::ys ) 
	    nil (Listsort.sort String.compare xs)

	(* Vergleicht zwei sortierte (!) Listen ohne doppelauftreten
	 * und gibt die Unterschiede in einer Liste aus *)
	fun intersection xs nil = nil
	  | intersection nil ys = nil
          | intersection (x::xs) (y::ys) = if (x=y) then (x::(intersection xs ys))
					 else if (x < y) then (intersection xs (y::ys))
					     else (intersection (x::xs) ys) 

	(* Gibt eine Liste von allen allquantifizierten gebundenen Variablen 
	 * in einer Praemisse zurueck *)
	fun getPremisseBnds (EQ(_,_)) = nil 
          | getPremisseBnds (ALL((t,i), m)) = (t,i)::(getPremisseBnds m)
          | getPremisseBnds _ = raise Error ("You can't apply Rewriting Rule on this premise \n")

	(* Gibt ein Goal zurueck, dass nun alle freien Variablen 
	 * enthaelt, die vorher gebunden waren *)
	fun Bnd2FreeVars nil goal = goal
          | Bnd2FreeVars ((t,s)::xs) goal = 
	    let
		val freemaps2i = Goal.freemaps2i(goal)
		val known = (freemaps2i s; true) handle Error _ => false
		val newgoal = if known then goal else 
		    Goal.update_ftypeenv(goal, s, t)
	    in Bnd2FreeVars xs newgoal end

	(* Ersetze alle gebundenen Variablen durch die entsprechend
	 * neu engefuehrten freien Variablen *)
	fun translateBnd2Free (t as (EQ(m,m'))) _ = t
          | translateBnd2Free (ALL((t,i), m))  (bmap,fmap) = 
	    let val bndname =  bmap i
		val freenr  =  fmap bndname 
	        val m'      =  (ETT.down 0 (ETT.sub m 0 (ETT.up 0 (V freenr) 1)) 1)
	    in translateBnd2Free m' (bmap,fmap) end
	  | translateBnd2Free _ _ = raise Error ("You can't apply Rewriting Rule on this premise \n")


	val pter = Goal.get_first_goal(goal)
	val bndmapi2s = Goal.bndmapi2s(goal)

	val position = getPosSequenz xs pter
	(* getSubTerm returns the wished subterm and the respect bnd Variables of the fixterm *)
	val (subterm, lambdas) = getSubTerm pter position nil
	val lamlevel = List.length(lambdas)
	
	(* DEBUG val _ = print ("Alter SUBTERM(FIX) : " ^ (Visual.pter2string subterm) ^ "\n") *)
	val def' =  let
			val left = ( case pter of IMP(l,_) => l | t => t )
		    in (* (print(Visual.pter2string(get_premisse left nr) ^ "\n\n")) *)
			get_premisse left nr 
		    end

	(* --------------------------- *)
	(* Sonderfall Kaper Routinen   *)
	(* --------------------------- *)
	(* FreetermBndvarsNr = Liste aller allquantifizierten BndVariables (Zahl)  im Freeterm *)
        val FreetermBndvarsNr    = getPremisseBnds (def')
	(* FreetermBndvarsNames = uebersetzt die Zifferndarstellung in Namen *) 
	val FreetermBndvarsNames' = (map (fn (t,i) => (t, bndmapi2s i)) FreetermBndvarsNr)
	val FreetermBndvarsNames  = remove_dbl (map (fn (t,s) => s ) FreetermBndvarsNames')
	(* FixtermBndvarsNames = Liste aller im Fixterm gebundenen Variablen *)
	val FixtermBndvarsNames  = remove_dbl (map (fn (_,i) =>  bndmapi2s i) lambdas)
	(* macht die neuen freien Variablen im Goal bekannt *)
	val newvargoal   = Bnd2FreeVars FreetermBndvarsNames' goal
	val freemaps2i   = Goal.freemaps2i(newvargoal)
	val freemapi2s   = Goal.freemapi2s(newvargoal)
	(* Neuer Freeterm jetzt nicht mehr gebunden !!! *)
	val freedef      = translateBnd2Free def' (bndmapi2s, freemaps2i)
	

	(* Berechne neues unifiziertes N ===> > N' < *)
	val newdest = startMatching (subterm, d) freedef lamlevel
	val newdestFreeVarsNr = ETT.getfreevars newdest 
	val newdestFreeVarsNames = 
	    remove_dbl ( map ( fn (V i) => freemapi2s i 
	  | _ => raise Error ("Internal Error in Rewriting Module (2)"))
			newdestFreeVarsNr)
	    
	(* allegekaperten Variablen ! *)
	val intersect = intersection newdestFreeVarsNames FixtermBndvarsNames
	(* pruefe nun, ob kapern erlaubt war !! *)
	val _ = foldl ( fn (s,_) => 
		       if (List.exists (fn z => z = s) FreetermBndvarsNames) then () 
		       else raise Error ("Free Variable "^s^" was captured --> Missing Allquantifier !\n"))
	    () intersect
	    

	val newpter = setSubTerm pter position newdest
	
	val newgoal' = Goal.update_first_goal(newvargoal, newpter)
	val newgoal  = Goal.kaper_check(newgoal')
			     
    in
	(Goal.print_goal(newgoal); newgoal )
    end


(* -------------------------------------------------------------- *)
(*                     Axiom/Lemma - Fall                         *)
(* -------------------------------------------------------------- *)


 | main'(goal, (xs, (LAXIOM(name,d)) ) ) = 
    let 
	val pter = Goal.get_first_goal(goal)
	(* val _ = (print ("DEBUG XS: ");  foldl ( fn(x,_) => print (Int.toString(x) ^ " ") ) () xs ) *)
	val position = getPosSequenz xs pter
	(* getSubTerm returns the wished subterm and the respect lambda level *)
	val (subterm, lambdas) = getSubTerm pter position nil
	val lamlevel = List.length(lambdas)
	(* DEBUG val _ = print ("Alter SUBTERM(FIX) : " ^ (Visual.pter2string subterm) ^ "\n") *)
	val def' = Goal.get_definition(goal, name)
		
	val newdest = startMatching (subterm, d) def' lamlevel
	val newpter = setSubTerm pter position newdest
	
	val workgoal = 
	    case ( Goal.get_definitions_kind(goal, name) ) of
		LEMMA => Apply.addLemma(goal, name)
	      | _     => goal                                 
	   
	val newgoal' = Goal.update_first_goal(workgoal, newpter)
	val newgoal  = Goal.kaper_check(newgoal')
			     
    in
	(Goal.print_goal(newgoal); newgoal )
    end


(* In case of Labeling, we have to translate the pos list first *)
fun main (goal, (ps, mode)) = 
let 
    val pter = Goal.get_first_goal(goal)
in
    main' (goal, ((translate pter ps), mode))
end


end (* of local open *)

