# Unix Makefile for lexyacc example

MOSMLHOME=/usr/local/mosml
MOSMLTOOLS=camlrunm $(MOSMLHOME)/tools
MOSMLC=mosmlc -c
MOSMLL=mosmlc 
MOSMLLEX=mosmllex
MOSMLYACC=mosmlyac

all: Hilfe.uo Paths.uo Data.uo ETT.uo PrettyPrint.uo Visual.uo Typecheck.uo Env.ui Env.uo Definition.ui Definition.uo Gamma.ui Gamma.uo Goal.ui Goal.uo Position.uo LatexOutput.uo Equality.uo Intro.uo Lexer.uo Elim.uo Instance.uo Cut.uo Move.uo Remove.uo Shift.uo Bool.uo Lambda.uo Apply.uo Unify.ui Unify.uo Rewriting.uo RefSymTrans.uo Insert.uo Main.uo Parser.uo
	$(MOSMLL) -o ../ned Main.uo

Parser.sml Parser.sig: Parser.grm
	$(MOSMLYACC) Parser.grm

.SUFFIXES :
.SUFFIXES : .sml .sig .ui .uo .mlp .lex .c .o

.sig.ui:
	$(MOSMLC) $<

.sml.uo:
	$(MOSMLC) $<

.lex.sml:
	$(MOSMLLEX) $<

depend: Lexer.sml Parser.sml 
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLTOOLS)/cutdeps < Makefile.bak > Makefile
	$(MOSMLTOOLS)/mosmldep >> Makefile

clean:
	rm -f Parser.sig Parser.sml Lexer.sml
	rm -f *.ui *.uo
	rm -f Makefile.bak
	rm -f *~
	rm -f *\#

### DO NOT DELETE THIS LINE
Parser.ui: Data.uo 
Parser.uo: Parser.ui Data.uo 
Lexer.uo: Parser.ui 
Main.uo: Parser.ui Lexer.uo
