;; Exp 2004/04/17 23:40:00 8.0 
;; syntax

(setq
 nedpg-forget-id-command "del %s.\n"
 nedpg-forget-proof-command "del_proof %s.\n"
 nedpg-forget-new-elim-command "edel elim %s.\n"
 nedpg-forget-new-intro-command "edel intro %s.\n"
 nedpg-forget-new-equation-command "edel equation %s.\n"
 nedpg-forget-close-def-command "edel closed %s.\n"
; nedpg-comments-regexp : a sequence of comments and white spaces
 nedpg-comments-regexp "[ \n\t\r]*\\((\\*\\([^*]\\|\\(\\*[^)]\\)\\)*\\*)[ \n\t\r]*\\)*"
; nedpg-strict-comments-regexp : a not empty sequence of comments and white spaces
 nedpg-strict-comments-regexp "\\([ \n\t\r]+\\((\\*\\([^*]\\|\\(\\*[^)]\\)\\)*\\*)[ \n\t\r]*\\)*\\|\\((\\*\\([^*]\\|\\(\\*[^)]\\)\\)*\\*)[ \n\t\r]*\\)+\\)"
 nedpg-ident-regexp "\\(\\([^() \n\t\r=\\[.]\\|\\(\\.[^() \n\t\r]\\)\\)+\\)"
 nedpg-inductive-option "\\(\\[[^]]*]\\)?"
 nedpg-spaces-regexp "[ \n\t\r]*"
 nedpg-sy-definition-regexp (concat 
   "\\(Cst\\|\\(def\\(rec\\)?\\)\\)"
   nedpg-comments-regexp
   "\\(\\(rInfix\\|lInfix\\|Infix\\|Prefix\\|Postfix\\)[^\"]+\"\\([^\"]+\\)\\)") 
 nedpg-sy-inductive-regexp (concat 
   "Inductive"
   nedpg-comments-regexp
   nedpg-inductive-option
   nedpg-comments-regexp
   "\\(\\(rInfix\\|lInfix\\|Infix\\|Prefix\\|Postfix\\)[^\"]+\"\\([^\"]+\\)\\)") 
 nedpg-inductive-regexp (concat 
   "Inductive"
   nedpg-comments-regexp
   nedpg-inductive-option
   nedpg-comments-regexp
   nedpg-ident-regexp) 
 nedpg-data-regexp (concat 
   "\\(Data\\|type\\)"
   nedpg-comments-regexp
   nedpg-inductive-option
   nedpg-comments-regexp
   nedpg-ident-regexp) 
 nedpg-definition-regexp (concat
   "\\(Cst\\|def\\(_thlist\\|rec\\)?\\|claim\\|Sort\\)"
   nedpg-comments-regexp
   nedpg-ident-regexp)
 nedpg-prove-claim-regexp (concat
   "prove_claim"
   nedpg-comments-regexp
   nedpg-ident-regexp)
 nedpg-new-elim-regexp (concat
   "new_elim\\([^.]\\|\\(\\.[^ \n\t\r]\\)\\)*[ \n\t\r)]"
   nedpg-ident-regexp)
 nedpg-new-intro-regexp (concat
   "new_intro\\([^.]\\|\\(\\.[^ \n\t\r]\\)\\)*[ \n\t\r)]"
   nedpg-ident-regexp)
 nedpg-new-rewrite-regexp (concat
   "new_rewrite\\([^.]\\|\\(\\.[^ \n\t\r]\\)\\)*[ \n\t\r)]"
   nedpg-ident-regexp)
 nedpg-new-equation-regexp (concat
   "new_equation\\([^.]\\|\\(\\.[^ \n\t\r]\\)\\)*[ \n\t\r)]"
   nedpg-ident-regexp)
 nedpg-close-def-regexp (concat
   "close_def"
   nedpg-comments-regexp
   "\\(\\([^.]\\|\\(\\.[^ \n\t\r]\\)\\)+\\)[. \n\t\r]")
)


(defun nedpg-init-syntax-table (&optional TABLE)
  "Set appropriate values for syntax table in current buffer, 
or for optional argument TABLE."
;; useful for using forward-word
  (modify-syntax-entry ?_  "w" TABLE)
  (modify-syntax-entry ?\. "w" TABLE)
;; Configure syntax table for block comments
  (modify-syntax-entry ?\* ". 23" TABLE)
  (modify-syntax-entry ?\( "()1"  TABLE)
  (modify-syntax-entry ?\) ")(4"  TABLE)
;;  complter ventuellement
)


;; completions :

(defvar nedpg-top-keywords
'(
"const"
"var"
"def"
"lemma"
"axiom"
"type"
"help"
"print"
"undo"
"latex"
"save"
"reset"
"exit"  
"goal"
"with"
)
"Names of nedpg top commands."
)

(defvar nedpg-proof-keywords
'(
"apply"
"elim"
"remove"
"instance"
"move"
"shift"
"intro"
"cut"
"pos"
"rew"
"insert"
"ref"
"sym"
"trans"
"simplify"
"lam"
"beta"
"eta"
)
"Name of nedpg proof commands."
)



(defun nedpg-find-and-forget (span)
  (let (str ans tmp (lsp -1) name sname) ;; da: added name,sname.  are tmp/lsp not used?
    (while span 
      (setq str (span-property span 'cmd))

      (cond

       ((eq (span-property span 'type) 'comment))       

       ((eq (span-property span 'type) 'proverproc))

       ((eq (span-property span 'type) 'goalsave)
	(if (proof-string-match nedpg-prove-claim-regexp str)
	    (setq ans (concat (format nedpg-forget-proof-command 
				      (match-string 4 str)) ans))
	  (setq ans (concat (format nedpg-forget-id-command
				    (span-property span 'name)) ans))))

       ((proof-string-match nedpg-new-elim-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-new-elim-command 
				  (match-string 3 str)) ans)))

       ((proof-string-match nedpg-new-intro-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-new-intro-command 
				  (match-string 3 str)) ans)))

       ((proof-string-match nedpg-new-rewrite-regexp str) ; deprecated
	(setq ans 
	      (concat (format nedpg-forget-new-equation-command 
				  (match-string 3 str)) ans)))

       ((proof-string-match nedpg-new-equation-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-new-equation-command 
				  (match-string 3 str)) ans)))

       ((proof-string-match nedpg-close-def-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-close-def-command 
				  (match-string 4 str)) ans)))

       ((proof-string-match nedpg-sy-definition-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-id-command 
				  (concat "$" (match-string 7 str))) ans)))

       ((proof-string-match nedpg-sy-inductive-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-id-command 
				  (concat "$" (match-string 10 str))) ans)))

       ((proof-string-match nedpg-inductive-regexp str)
	(setq ans 
	      (concat (format nedpg-forget-id-command 
				  (match-string 8 str)) ans)))

       ((proof-string-match nedpg-data-regexp str)
	(setq
	  name (match-string 8 str)
          sname (concat (downcase (substring name 0 1)) 
			(substring name 1 nil))
	  ans (concat (format nedpg-forget-id-command 
			      sname) ans)))

       ((proof-string-match nedpg-definition-regexp str)
	(setq ans (concat (format nedpg-forget-id-command 
				      (match-string 6 str)) ans))))

      (setq lsp (span-start span))
      (setq span (next-span span 'type)))

      (or ans proof-no-command)))

;;
;; Doing commands
;;

(defun nedpg-assert-next-command-interactive ()
  "Process until the end of the next unprocessed command after point.
If inside a comment, just process until the start of the comment."
  (interactive)
;  (if (and (> (point) 1) (char-equal (char-before (point)) ?\.)) (insert "\n"))
  (proof-with-script-buffer
   (proof-maybe-save-point
    (goto-char (proof-queue-or-locked-end))
    (proof-assert-next-command))
   (proof-maybe-follow-locked-end)))

;;--------------------------------------------------------------------------;;
;; Obtaining some informations on the system.
;;
;;--------------------------------------------------------------------------;;
;; All the commands in section "Obtaining some informations on the
;; system."  (see cmd_top.tex) are associated to a
;; function, and appear in the submenu  "State" [pr].

(defun nedpg-depend-theorem(theorem)
  "Interactive function : 
ask for a string and  and send a depend command to Nedpg for it.

Gives the list of all axioms which have been used to prove the theorem."

(interactive "stheorem: ")
(proof-shell-invisible-command (concat "depend " theorem)))

(defun nedpg-eshow-extlist(extlist)
  "Interactive function : 
ask for a string and send an eshow command to Nedpg for it. 

Shows the given extension-list.  Possible extension lists are : equation
(the list of equations added to unification introduced by the new_equation
command), elim, intro, (the introduction and elimination rules
introduced by the new_elim and new_intro {-t} commands), closed
(closed definitions introduced by the close_def command) and tex
(introduced by the tex_syntax command)."

(interactive "sextension list: ")
(proof-shell-invisible-command (concat "eshow " extlist)))

(defun nedpg-flag-name(name)
"Interactive function : 
ask for a string and send a flag command  to Nedpg for it.

  Print the value of an internal flag of the
  system. The different flags are listed in the doc, see flag."

(interactive "sname: ")
(proof-shell-invisible-command (concat "flag " name)))


(defun nedpg-path()
"Interactive function : 
 send a path command to Nedpg.

  Prints the list of all paths. This path list is used to find
  files when using the include command."


(interactive)
(proof-shell-invisible-command  "path"))

(defun nedpg-print-expression(expr)
"Interactive function : 
ask for a string and send a print command  to Nedpg for it.

  In case argument expr
  is a closed expression of the language in use, prints it and gives its
  sort, gives an (occasionally) informative error message otherwise. In
  case expr is a definedpg expression (constant, theorem ...) 
  gives  the definition."

(interactive "sexpr: ")
(proof-shell-invisible-command (concat "print " expr)))

(defun nedpg-print-sort-expression(expr)
"Interactive function : 
ask for a string and send a print_sort command  to Nedpg for it.

  Similar to print, but gives more information on sorts of bounded
  variable in expressions."

(interactive "sexpr: ")
(proof-shell-invisible-command (concat "print_sort " expr)))


(defun nedpg-priority-symbols-list(symblist)
"Interactive function : 
ask for a string and send a priority command  to Nedpg for it.

  Print the priority of the given symbols. If no symbol are
  given, print the priority of all infix and prefix symbols.
."

(interactive "slist of symbols (possibly empty): ")
(proof-shell-invisible-command (concat "priority" symblist)))


(defun nedpg-search-string(string type)
  "Interactive function: 
ask for a string and possibly a type and send a search command to Nedpg for it.

 Prints the list of all loaded symbols which have type and whose name
 contains the string. If no type is given, it prints all symbols whose
 name contains string."

(interactive 
"sstring : 
stype (nothing for any type, 'a as type parameter) :")
(proof-shell-invisible-command (concat "search \"" string "\" " type)))

;; The followings are proof commands (doc in cmd_proof.tex) :

(defun nedpg-constraints()
"Interactive function : 
 send a constraints command to Nedpg.

  Prints the  constraints which should be fulfilled by unification variables,
  only works in proofs."


(interactive)
(proof-shell-invisible-command  "constraints"))

(defun nedpg-goals()
"Interactive function : 
 send a goals command to Nedpg.

  Prints the list of all remaining goals, only works in proofs."


(interactive)
(proof-shell-invisible-command  "goals"))

;; menu

(defvar nedpg-state-menu
  '("State"
["dependencies of a theorem" nedpg-depend-theorem t]
["show an extension list" nedpg-eshow-extlist t]
["value of a flag" nedpg-flag-name t]
["list of all paths" nedpg-path t]
["print expression" nedpg-print-expression  t]
["print expression with sorts" nedpg-print-sort-expression  t]
["priority of symbols (all if arg. empty)" nedpg-priority-symbols-list t]
["search for loaded symbols matching string" nedpg-search-string t]
["------------------" nil nil]
["constraints      (proof command)" nedpg-constraints t]
["goals               (proof command)" nedpg-goals t]
)
"Nedpg menu for informations on state of the system."
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;--------------------------------------------------------------------------;;
;;
;;    Deleting symbols
;;
;;--------------------------------------------------------------------------;;
;; obsolte probablement, sinon  modifier pour en tendre la porte.

(defun nedpg-delete-symbol(symbol)
  "Interactive function : 
ask for a symbol and send a delete command to Nedpg for it."
  (interactive "ssymbol : ")
  (proof-shell-invisible-command (concat "del " symbol)))

(defun nedpg-delete-symbol-on-cursor()
"Interactive function : 
send a delete command to Nedpg for the symbol whose name is under the cursor."
  (interactive)
  (let (start end)
    (save-excursion
      (forward-word -1)
      (setq start (point))
      (forward-word 1)
      (setq end (point)))
    (if (char-equal (char-after (- end 1)) ?\.)(setq end (- end 1)))
    (nedpg-delete-symbol (buffer-substring start end))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(provide 'nedpg-fun)


    
